import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import com.borland.jbcl.layout.*;
import java.sql.*;
import java.io.File;
import java.util.Vector;

public class GUICreator extends JFrame implements Constants {
  private JScrollPane jScrollPane1 = new JScrollPane();
  private BorderLayout borderLayout1 = new BorderLayout();
  private JPanel jPanel1 = new JPanel();
  private BorderLayout borderLayout2 = new BorderLayout();
  private JPanel jPanel2 = new JPanel();
  private JButton btnClose = new JButton();
  private FlowLayout flowLayout1 = new FlowLayout();
  private JButton btnExcecute = new JButton();
  private JPanel pnlHeader = new JPanel();
  private JPanel pnlContent = new JPanel();
  private XYLayout xYLayout1 = new XYLayout();
  private JScrollPane jScrollPane2 = new JScrollPane();
  private JTextArea txtaQueries = new JTextArea();
  private JTextArea txtaComment = new JTextArea();
  private JScrollPane jScrollPane3 = new JScrollPane();
  private JTextArea txtaStatus = new JTextArea();
  private JLabel jLabel1 = new JLabel();
  private JTextField txtfDBname = new JTextField();
  private BorderLayout borderLayout3 = new BorderLayout();
  private JButton btnClear = new JButton();
  private JButton btnChooseCatalogForDB = new JButton();
  private JLabel jLabel2 = new JLabel();
  private JTextField txtfCatalog = new JTextField();
  private File katalogDB = new File("files");
  private JButton btnClearStatus = new JButton();

  public GUICreator() {
    super("HSQLDB DatabaseCreator 1.0 - Developed by Tom Fladsrud");
    try {
      jbInit();
      this.txtaComment.setBackground(this.btnClose.getBackground());
      this.txtfCatalog.setText(katalogDB.getAbsolutePath());
      this.setSize(588, 590);
      this.centerVindu(this);
      this.setResizable(false);

      this.show();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

      private static void centerVindu (JFrame f) {
        Dimension skjermSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension vinduSize = f.getSize();
        if (vinduSize.height > skjermSize.height) {
            vinduSize.height = skjermSize.height;
        }
        if (vinduSize.width > skjermSize.width) {
            vinduSize.width = skjermSize.width;
        }
        f.setLocation((skjermSize.width - vinduSize.width)/2, (skjermSize.height
                - vinduSize.height)/2);
    }



  private void jbInit() throws Exception {
    this.getContentPane().setLayout(borderLayout1);
    jPanel1.setLayout(borderLayout2);
    jPanel2.setPreferredSize(new Dimension(10, 50));
    jPanel2.setLayout(flowLayout1);
    btnClose.setText("Close");
    btnClose.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnClose_actionPerformed(e);
      }
    });
    flowLayout1.setAlignment(FlowLayout.RIGHT);
    btnExcecute.setText("Run Query");
    btnExcecute.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnExcecute_actionPerformed(e);
      }
    });
    pnlHeader.setPreferredSize(new Dimension(10, 70));
    pnlHeader.setLayout(borderLayout3);
    pnlContent.setLayout(xYLayout1);
    txtaComment.setEditable(false);
    txtaComment.setText("Type or paste the query to be executed. Separate commands with ;");
    txtaStatus.setEditable(false);
    jLabel1.setText("Database name");
    btnClear.setText("Clear SQL");
    btnClear.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnClear_actionPerformed(e);
      }
    });
    btnChooseCatalogForDB.setText("Browse");
    btnChooseCatalogForDB.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnChooseCatalogForDB_actionPerformed(e);
      }
    });
    jLabel2.setText("Catalog to place the database");
    txtfCatalog.setEditable(false);
    btnClearStatus.setText("Clear Status");
    btnClearStatus.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnClearStatus_actionPerformed(e);
      }
    });
    this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
    pnlContent.add(txtfDBname, new XYConstraints(102, 60, 470, 19));
    pnlContent.add(jScrollPane2, new XYConstraints(4, 127, 569, 147));
    pnlContent.add(txtaComment, new XYConstraints(5, 83, 568, 38));
    pnlContent.add(jScrollPane3, new XYConstraints(4, 280, 569, 150));
    pnlContent.add(jLabel1, new XYConstraints(6, 60, -1, -1));
    jScrollPane3.getViewport().add(txtaStatus, null);
    jScrollPane2.getViewport().add(txtaQueries, null);
    this.getContentPane().add(jScrollPane1,  BorderLayout.CENTER);
    jScrollPane1.getViewport().add(jPanel1, null);
    jPanel1.add(jPanel2,  BorderLayout.SOUTH);
    jPanel2.add(btnExcecute, null);
    jPanel2.add(btnClearStatus, null);
    jPanel2.add(btnClear, null);
    jPanel2.add(btnClose, null);
    jPanel1.add(pnlHeader, BorderLayout.NORTH);
    jPanel1.add(pnlContent, BorderLayout.CENTER);
    pnlHeader.add(new JLabel(new ImageIcon(headerpath)), BorderLayout.CENTER);
    pnlContent.add(jLabel2, new XYConstraints(5, 33, -1, -1));
    pnlContent.add(btnChooseCatalogForDB,      new XYConstraints(495, 29, -1, -1));
    pnlContent.add(txtfCatalog,                  new XYConstraints(174, 32, 315, -1));

  }

  void btnClose_actionPerformed(ActionEvent e) {
    System.exit(0);
  }


  public File velgKatalog(String defaultPath, String tittel){
      File returfil = null;
      try{
        File defaultpath = new File(defaultPath);
        JFileChooser filvelger = new JFileChooser(defaultpath);
        filvelger.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        filvelger.setDialogTitle(tittel);
        filvelger.setCurrentDirectory(defaultpath);
        int resultat = filvelger.showOpenDialog(this);
        if (resultat == JFileChooser.CANCEL_OPTION)
          return null;
        else{
          returfil = filvelger.getSelectedFile();
        }
      }catch(Exception e){
        JOptionPane.showMessageDialog(null, "Error during selection of database path.", "Error", JOptionPane.ERROR_MESSAGE);
      }
      return returfil;
      }


  void btnExcecute_actionPerformed(ActionEvent e) {
    if(this.txtfDBname.getText().trim().equals("")){
      this.txtaStatus.append("Error::Field database name must have value");
      this.txtfDBname.requestFocus();
      return;
    }
    try{
      if(!katalogDB.exists())
        katalogDB.mkdirs();
    }catch(Exception ef){
      ef.printStackTrace();
    }
    String dbname = katalogDB.getAbsolutePath()+"\\"+this.txtfDBname.getText().trim();
    DatabaseConnection dbcon;

    try{
      dbcon = new DatabaseConnection(dbname, dbpw, dbuser, dbURL, forname);
    }catch(Exception ed){
      this.txtaStatus.append("Could not connect to database.\n"+ed.getMessage());
      ed.printStackTrace();
      return;
    }

    String queries = this.txtaQueries.getText();
    int q=0;
    String arr_queries[] = queries.split(";");
    try{
        this.txtaStatus.append("RESULT RETURNED FROM DATABASE:\n");
      for(; q<arr_queries.length; q++){
        Vector ret = dbcon.query(arr_queries[q].trim());
        if(ret!= null){
          for(int s= 0; s<ret.size(); s++){
              Object obj[] = (Object[])ret.elementAt(s);
              for(int s2= 0; s2<obj.length; s2++){
                this.txtaStatus.append(obj[s2].toString()+"\t");
              }
              this.txtaStatus.append("\n");
          }
        }else{
          this.txtaStatus.append((arr_queries[q].startsWith("SELECT")?"NO RESULT RETURNED FROM DATABASE\n":""));
        }
      }
    }catch(SQLException sqle){
      this.txtaStatus.append("ERROR AT LINE "+q+"\n"+arr_queries[q]+"\nMessage from system: "+sqle.getMessage()+"\nROLLBACK WILL BE PERFORMED");
      try{
        dbcon.query("ROLLBACK");
        txtaStatus.append("\nROLLBACK WAS SUCCESSFUL");
      }catch(SQLException sqle2){
          txtaStatus.append("\nROLLBACK FAILED");
      }
      return;
    }
    try{
      dbcon.query("COMMIT");
      this.txtaStatus.append("QUERY EXCECUTED SUCCESSFULLY");
    }catch(SQLException sqle2){txtaStatus.append("\nCOMMIT FAILED");}
//      this.txtaStatus.append("QUERY EXCECUTED SUCCESSFULLY");

  }

  void btnClear_actionPerformed(ActionEvent e) {
    this.txtaQueries.setText("");
  }

  void btnChooseCatalogForDB_actionPerformed(ActionEvent e) {
    File katalogtmp = katalogDB;
    katalogDB = this.velgKatalog(katalogDB.getAbsolutePath(), "Choose path for the database");
    if(katalogDB == null){
      katalogDB = katalogtmp;
    }
    this.txtfCatalog.setText(katalogDB.getAbsolutePath());
  }

  void btnClearStatus_actionPerformed(ActionEvent e) {
    this.txtaStatus.setText("");
  }




}